package com.hand.hls.dp.controllers.v2;

import com.hand.hap.core.IRequest;
import com.hand.hap.core.impl.RequestHelper;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import com.hand.hls.dp.service.SysDpDownloadLogService;
import com.hand.hls.dp.service.SysDpExecuteHistoryService;
import com.hand.hls.dp.util.IPUtils;
import leaf.bean.LeafRequestData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author <a href="mailto:zhangnet14@gmail.com">Spencer Chang</a>
 * @date 2020/4/18 15:31
 * @since
 */
@RestController
public class SysDpExecuteHistoryV2Controller extends BaseController {

    @Autowired
    private SysDpExecuteHistoryService service;
    @Autowired
    private SysDpDownloadLogService downloadLogService;

    @PostMapping(value = "/sys/dp/v2/execute")
    public ResponseData query(@ModelAttribute(LEAF_PARAM_NAME) LeafRequestData requestData,
                              HttpServletRequest request) throws Exception {
        IRequest requestContext = createRequestContext(request);
        RequestHelper.setCurrentRequest(requestContext);
        final String ip = IPUtils.getIpAddress(request);
        final String dpContext = (String) requestData.get("parameter");
        return service.execute(requestContext, ip, dpContext);
    }

    @PostMapping(value = "/sys/dp/v2/collect/log")
    public void collectLog(HttpServletRequest request, HttpServletResponse response) throws Exception{
        IRequest requestContext = createRequestContext(request);
        // 发布消息收集日志
        downloadLogService.collectLog(requestContext, request, response);
        Thread.sleep(6000);
        // 下载日志
        downloadLogService.downloadClusterLogZipFile(requestContext, request, response);
    }
}
